#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include "common.h"

void		processConfig();

int		optGuestTime;
int		nLogins;
LoginRec	loginRec[MAX_USERS];

void main() {
  int i, found = 0;
  char login[UT_NAMESIZE + 1], ttyName[UT_LINESIZE];
  uid_t uid = getuid();
  UserRec ur;
  loginFromUID(login, uid);
  if (!strcmp(login, "guest")) {
    processConfig();
    strcpy(ttyName, ttyname(STDIN_FILENO));
    userList(&nLogins, loginRec);
    for (i = 0; i < nLogins; i++)
      if (!strcmp(ttyName + 5, loginRec[i].tty)) {
	found = 1;
        ur.tLeft = (optGuestTime * 60 - (time(NULL) - loginRec[i].time)) / 60 + 1;
        ur.sLeft = ur.tLeft;
      }
  } else {
    userFileOpen();
    if (!userFileSearch(&ur, uid)) found = 1;
    userFileClose();
  }
  if (!found) printf("no time limit!\n");
  else {
    ur.tLeft = max(0, ur.tLeft);
    ur.sLeft = max(0, ur.sLeft);
    if (ur.tLeft != ur.sLeft) printf("%d minute(s) remaining in this accounting period.\n", ur.tLeft);
    printf("%d minute(s) remaining in this session.\n", ur.sLeft);
  }
}

void processConfig() {
  int li;
  char line[256], token[256];
  FILE *f;
  if ((f = fopen(configFilePath, "rt")) == NULL)
    errQuit("couldn't open config file");
  while (fgets(line, 256, f) != NULL) {
    li = 0;
    if (getToken(token, line, &li)) continue;
    if (!strcasecmp(token, "Guest-Time")) {
      if (getToken(token, line, &li)) continue;
      optGuestTime = atoi(token);
    }
  }
  fclose(f);
}
