#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "common.h"

void	processConfig();
int	userFileSearchPhNo(word phNoArea, word phNoLocal);

int	phNoDigits;

void main(int argc, char **argv) {
  uid_t uid;
  BanRec br;
  UserRec ur, ur2;
  char phNo[32];
  int i, session_limit, priority;
  bzero(&ur, sizeof(UserRec));
  if (argc < 4)
    errQuit("usage: user_addrec <login> <expire> <time_limit> [session_limit] [priority] [phone_no]");
  session_limit = argc >= 5 ? atoi(argv[4]) : atoi(argv[3]);
  if (session_limit < 0 || session_limit > atoi(argv[3]))
    errQuit("invalid session_limit: %d", session_limit);
  priority = argc >= 6 ? atoi(argv[5]) : 4;
  if (priority < 0 || priority > 7)
    errQuit("invalid priority: %d", priority);
  if (argc >= 7) {
    processConfig();
    strcpy(phNo, argv[6]);
    for (i = 7; argv[i]; i++) {
      strcat(phNo, " ");
      strcat(phNo, argv[i]);
    }
    if (phNoToWords(&ur.phNoArea, &ur.phNoLocal, phNo, phNoDigits) || (ur.phNoArea && !ur.phNoLocal))
      errQuit("invalid phone number: %s", phNo);
    userFileOpen();
    if (!userFileSearchPhNo(ur.phNoArea, ur.phNoLocal))
      errQuit("phone number is already in use: %s", phNo);
    userFileClose();
    banFileOpen();
    if (!banFileSearch(&br, ur.phNoArea, ur.phNoLocal))
      errQuit("phone number is banned: %s", phNo);
    banFileClose();
  }
  uid = uidFromLogin(argv[1]);
  if (uid == (uid_t)-1)
    errQuit("user does not exist: %s", argv[1]);
  userFileOpen();
  if (!userFileSearch(&ur2, uid))
    errQuit("user already exists: %s", argv[1]);
  ur.uid = uid;
  ur.flags = priority << 1;
  ur.expire = addTime(argv[2]);
  ur.last = time(NULL);
  ur.tLimit = ur.tLeft = atoi(argv[3]);
  ur.sLimit = ur.sLeft = session_limit;
  fseek(userFile, 0, SEEK_END);
  userFileWrite(&ur);
  userFileClose();
  printf("user added: %s\n", argv[1]);
  exit(0);
}

void processConfig() {
  int li;
  char phNoLocalFormat[16], line[256], token[256];
  FILE *f;
  if ((f = fopen(configFilePath, "rt")) == NULL)
    errQuit("couldn't open config file");
  while (fgets(line, 256, f) != NULL) {
    li = 0;
    if (getToken(token, line, &li)) continue;
    if (!strcasecmp(token, "PhNoLocalFormat")) {
      if (getToken(token, line, &li)) continue;
      strcpy(phNoLocalFormat, token);
      while (!getToken(token, line, &li)) {
	strcat(phNoLocalFormat, " ");
	strcat(phNoLocalFormat, token);
      }
      phNoDigits = stringSum(phNoLocalFormat);
    }
  }
  fclose(f);
}

int userFileSearchPhNo(word phNoArea, word phNoLocal) {
  UserRec ur;
  rewind(userFile);
  while (!userFileRead(&ur))
    if (ur.phNoArea == phNoArea && ur.phNoLocal == phNoLocal)
      return 0;
  return 1;
}
