#include <pwd.h>
#include <string.h>
#include <unistd.h>
#include <utmp.h>
#include "common.h"

void		processConfig();
int		userExcluded(uid_t uid);

int		nExcluded;
uid_t		excluded[64];

void main(int argc, char **argv) {
  struct passwd *pw;
  int i, nArgs = 0;
  pid_t pid;
  char login[UT_NAMESIZE + 1], *arg[64];
  if (argc < 2) errQuit("usage: user_foreach <command>");
  processConfig();
  arg[nArgs] = argv[1];
  for (i = strlen(arg[nArgs]); i >= 0 && arg[nArgs][i] != '/'; i--);
  if (i >= 0) arg[nArgs] += i + 1;
  nArgs++;
  for (i = 2; i < argc; i++) {
    if (!strcmp(argv[i], "{}")) arg[nArgs++] = login;
    else arg[nArgs++] = argv[i];
  }
  arg[nArgs] = NULL;
  setpwent();
  while ((pw = getpwent()) != NULL) {
    if (userExcluded(pw->pw_uid)) continue;
    strncpy(login, pw->pw_name, UT_NAMESIZE);
    login[UT_NAMESIZE] = '\0';
    if ((pid = fork()) == 0) {
      execvp(argv[1], arg);
      perrQuit("exec");
    } else if (pid > 0) waitpid(pid, NULL, 0);
    else perrQuit("fork");
  }
  endpwent();
}

void processConfig() {
  int li;
  char line[256], token[256];
  FILE *f;
  if ((f = fopen(configFilePath, "rt")) == NULL)
    errQuit("couldn't open config file");
  while (fgets(line, 256, f) != NULL) {
    li = 0;
    if (getToken(token, line, &li)) continue;
    if (!strcasecmp(token, "ForeachExclude")) {
      while (!getToken(token, line, &li)) {
	excluded[nExcluded] = uidFromLogin(token);
	if (excluded[nExcluded] == (uid_t)-1) continue;
	else nExcluded++;
      }
    }
  }
  fclose(f);
}

int userExcluded(uid_t uid) {
  int i;
  for (i = 0; i < nExcluded; i++)
    if (excluded[i] == uid) return 1;
  return 0;
}
