#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <sys/wait.h>
#include <unistd.h>
#include "common.h"

void	processConfig();
int	userRenew();
int	banRenew();

char	phNoAreaFormat[16];
char	phNoLocalFormat[16];

void main() {
  processConfig();
  while (!userRenew());
  while (!banRenew());
}

void processConfig() {
  int li;
  char line[256], token[256];
  FILE *f;
  if ((f = fopen(configFilePath, "rt")) == NULL)
    errQuit("couldn't open config file");
  while (fgets(line, 256, f) != NULL) {
    li = 0;
    if (getToken(token, line, &li)) continue;
    if (!strcasecmp(token, "PhNoAreaFormat")) {
      if (getToken(token, line, &li)) continue;
      strcpy(phNoAreaFormat, token);
      while (!getToken(token, line, &li)) {
	strcat(phNoAreaFormat, " ");
	strcat(phNoAreaFormat, token);
      }
    } else if (!strcasecmp(token, "PhNoLocalFormat")) {
      if (getToken(token, line, &li)) continue;
      strcpy(phNoLocalFormat, token);
      while (!getToken(token, line, &li)) {
	strcat(phNoLocalFormat, " ");
	strcat(phNoLocalFormat, token);
      }
    }
  }
  fclose(f);
}

int userRenew() {
  time_t t;
  char login[9];
  UserRec ur;
  userFileOpen();
  time(&t);
  while (!userFileRead(&ur)) {
    if (ur.expire && t >= ur.expire) {
      userFileClose();
      loginFromUID(login, ur.uid);
      if (EXPIRE(ur.flags) == EXPIRE_DELETE)
	runCommand(SBIN"/user_del", login, NULL);
      else
	runCommand(SBIN"/user_unsubscribe", login, NULL);
      return 0;
    } else if (ur.tLeft != ur.tLimit) {
      ur.PPPsBytes = ur.PPPtBytes = 0;
      ur.tLeft = ur.tLimit;
      ur.sLeft = ur.sLimit;
      userFileEdit(&ur);
    }
  }
  userFileClose();
  return 1;
}

int banRenew() {
  time_t t;
  BanRec br;
  char phNo[32];
  banFileOpen();
  time(&t);
  while (!banFileRead(&br)) {
    if (br.expire && t >= br.expire) {
      banFileClose();
      runCommand(SBIN"/user_unban", wordsToPhNo(phNo, br.phNoArea, br.phNoLocal, phNoAreaFormat, phNoLocalFormat));
      return 0;
    }
  }
  banFileClose();
  return 1;
}
