#include <assert.h>
#include <unistd.h>
#include <pwd.h>
#include <string.h>
#include "common.h"

void	processConfig();

int	phNoDigits;

void main(int argc, char **argv) {
  int i, n;
  BanRec br;
  char tBanPath[16], phNo[32];
  FILE *tBanFile;
  processConfig();
  if (argc < 2)
    errQuit("usage: user_unban <phone_no>");
  strcpy(phNo, argv[1]);
  for (i = 2; argv[i]; i++) {
    strcat(phNo, " ");
    strcat(phNo, argv[i]);
  }
  if (phNoToWords(&br.phNoArea, &br.phNoLocal, phNo, phNoDigits))
    errQuit("invalid phone number: %s", phNo);
  strcpy(tBanPath, "/tmp/XXXXXX"); mktemp(tBanPath);
  banFileOpen();
  if (banFileSearch(&br, br.phNoArea, br.phNoLocal))
    errQuit("phone number not found: %s", phNo);
  tBanFile = fopen(tBanPath, "wb"); assert(tBanFile != NULL);
  n = ftell(banFile) / sizeof(BanRec) - 1;
  rewind(banFile);
  for (i = 0; ; i++) {
    if (banFileRead(&br)) break;
    if (i == n) continue;
    fwrite(&br, sizeof(BanRec), 1, tBanFile);
  }
  banFileClose(); fclose(tBanFile);
  fCopy(tBanPath, (char*)banFilePath); unlink(tBanPath);
  printf("phone number unbanned: %s\n", phNo);
}

void processConfig() {
  int li;
  char phNoLocalFormat[16], line[256], token[256];
  FILE *f;
  if ((f = fopen(configFilePath, "rt")) == NULL)
    errQuit("couldn't open config file");
  while (fgets(line, 256, f) != NULL) {
    li = 0;
    if (getToken(token, line, &li)) continue;
    if (!strcasecmp(token, "PhNoLocalFormat")) {
      if (getToken(token, line, &li)) continue;
      strcpy(phNoLocalFormat, token);
      while (!getToken(token, line, &li)) {
	strcat(phNoLocalFormat, " ");
	strcat(phNoLocalFormat, token);
      }
      phNoDigits = stringSum(phNoLocalFormat);
    }
  }
  fclose(f);
}
